package com.javaminecraft;

import java.util.logging.Level;
import java.util.logging.Logger;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

/**
 * Breaks hanging wood blocks for easier tree farming.
 * @version 1.7
 * @author Sam Stalboerger
 */
public class Timberfall extends JavaPlugin implements Listener {
    public static final Logger LOG = Logger.getLogger("Minecraft");
    
    boolean modon = true;
    
    @EventHandler
    public void onBlockBreak(BlockBreakEvent event) {
        Block block = event.getBlock();
        if (modon) {
            while(block.getRelative(BlockFace.UP).getType().equals(
                    Material.LOG) | block.getRelative(BlockFace.UP).getType(
                    ).equals(Material.LOG_2)) {
                block = block.getRelative(BlockFace.UP);
                ItemStack tool = new ItemStack(Material.DIAMOND_AXE);
                if (!block.breakNaturally(tool)) {
                    LOG.warning("[Timberfall] Error Breaking wood block. " 
                    + "Converting to air.");
                    block.setType(Material.AIR);
                } else {
                    LOG.fine("[Timberfall] Broke hanging wood block.");
                }
            }
        }
    }
    
    @Override
    public void onEnable() {
        Server server = getServer();
        PluginManager manager = server.getPluginManager();
        manager.registerEvents(this, this);
        LOG.warning("[Timberfall] is currently running an alpha version.");
    }
    
    @Override
    public boolean onCommand(CommandSender sender, Command command, 
            String label, String[] arguments) {
        if (label.equalsIgnoreCase("toggletreefall")) {
            modon = !modon;
            LOG.log(Level.INFO, "[Timberfall] Switching mod activation to {0}.",
                    modon);
            return true;
        }
        return false;
    }     
}